import java.awt.*;

public class DrawingObjectGasolineTanker implements IDrawingObject {

    private DrawingGasolineTanker _gasolineTanker;

    public DrawingObjectGasolineTanker(DrawingGasolineTanker gasolineTanker)
    {
        _gasolineTanker= gasolineTanker;
    }

    public float Step() {
        if(_gasolineTanker != null && _gasolineTanker.GasolineTanker != null)
            return _gasolineTanker.GasolineTanker.Step;
        return 0;
    }

    @Override
    public void SetObject(int x, int y, int width, int height) {
        _gasolineTanker.SetPosition(x,y,width,height);
    }

    @Override
    public void MoveObject(Direction direction) {
        _gasolineTanker.MoveTransport(direction);
    }

    @Override
    public void DrawingObject(Graphics g) {
        _gasolineTanker.DrawTransport(g);
    }

    @Override
    public float[] GetCurrentPosition() {
        if(_gasolineTanker!=null)
            return _gasolineTanker.GetCurrentPosition();
        return null;
    }
    public DrawingGasolineTanker GetGasolineTanker() {
        return _gasolineTanker;
    }
}
